<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Tags.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Tags.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Tags.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;HTML Tag generation utilities.</span></span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-string">You will probably find it easiest to import * from this module.&quot;&quot;&quot;</span></span>
<a id="line11"></a><span class="lineno"> 11</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">using_frames = True <span class="py-comment">#overwritten by Formatter...</span></span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#attributes">attributes</a>(keys):</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">    <span class="py-string">&quot;Convert a name/value dict to a string of attributes&quot;</span></span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-keyword">return</span> <span class="py-string">' '</span>.join([<span class="py-string">'%s=&quot;%s&quot;'</span>%(k,v) <span class="py-keyword">for</span> k,v <span class="py-keyword">in</span> keys.items()])</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#rel">rel</a>(origin, target):</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    <span class="py-string">&quot;Find link to target relative to origin.&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    origin, target = origin.split(<span class="py-string">'/'</span>), target.split(<span class="py-string">'/'</span>)</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">    <span class="py-keyword">if</span> len(origin) &lt; len(target): check = len(origin) - 1</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">    <span class="py-keyword">else</span>: check = len(target) - 1</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">    <span class="py-keyword">for</span> l <span class="py-keyword">in</span> range(check):</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">        <span class="py-keyword">if</span> target[0] == origin[0]:</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">            <span class="py-keyword">del</span> target[0]</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">            <span class="py-keyword">del</span> origin[0]</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">        <span class="py-keyword">else</span>: <span class="py-keyword">break</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">    <span class="py-comment"># If origin is a directory, and target is in that directory, origin[0] == target[0]</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">    <span class="py-keyword">if</span> len(origin) == 1 <span class="py-keyword">and</span> len(target) &gt; 1 <span class="py-keyword">and</span> origin[0] == target[0]:</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">        <span class="py-comment"># Remove directory from target, but respect len(origin) - 1 below</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">        <span class="py-keyword">del</span> target[0]</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">    <span class="py-keyword">if</span> origin: target = [<span class="py-string">'..'</span>] * (len(origin) - 1) + target</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">    <span class="py-keyword">return</span> <span class="py-string">'/'</span>.join(target)</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#href">href</a>(_ref, _label, **attrs):</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">    <span class="py-string">&quot;Return a href to 'ref' with name 'label' and attributes&quot;</span></span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">    <span class="py-comment"># Remove target if not using frames</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">    <span class="py-keyword">if</span> attrs.has_key(<span class="py-string">'target'</span>) <span class="py-keyword">and</span> <span class="py-keyword">not</span> using_frames:</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        <span class="py-keyword">del</span> attrs[<span class="py-string">'target'</span>]</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    <span class="py-keyword">return</span> <span class="py-string">'&lt;a href=&quot;%s&quot; %s&gt;%s&lt;/a&gt;'</span>%(_ref,attributes(attrs),_label)</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#img">img</a>(**attrs):</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">    <span class="py-string">&quot;Return an img element.&quot;</span></span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">    <span class="py-keyword">return</span> <span class="py-string">'&lt;img %s/&gt;'</span>%attributes(attrs)</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#name">name</a>(ref, label):</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">    <span class="py-string">&quot;Return a name anchor with given reference and label&quot;</span></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">    <span class="py-keyword">if</span> <span class="py-string">'('</span> <span class="py-keyword">in</span> ref: <span class="py-keyword">raise</span> error</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">    <span class="py-keyword">return</span> <span class="py-string">'&lt;a class=&quot;name&quot; id=&quot;%s&quot;&gt;%s&lt;/a&gt;'</span>%(ref,label)</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#span">span</a>(class_, body):</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">    <span class="py-string">&quot;Wrap the body in a span of the given class&quot;</span></span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">    <span class="py-keyword">if</span> class_:</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;span class=&quot;%s&quot;&gt;%s&lt;/span&gt;'</span>%(class_,body)</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">    <span class="py-keyword">else</span>:</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;span&gt;%s&lt;/span&gt;'</span>%body</span>
<a id="line62"></a><span class="lineno"> 62</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#div">div</a>(class_, body):</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">    <span class="py-string">&quot;Wrap the body in a div of the given class&quot;</span></span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">    <span class="py-keyword">if</span> class_:</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;div class=&quot;%s&quot;&gt;%s&lt;/div&gt;'</span>%(class_,body)</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">    <span class="py-keyword">else</span>:</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;div&gt;%s&lt;/div&gt;'</span>%body</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#element">element</a>(_, body = None, **keys):</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">    <span class="py-string">&quot;Wrap the body in a tag of given type and attributes&quot;</span></span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">    <span class="py-keyword">if</span> body:</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;%s %s&gt;%s&lt;/%s&gt;'</span>%(_, attributes(keys), body, _)</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    <span class="py-keyword">else</span>:</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'&lt;%s %s /&gt;'</span>%(_, attributes(keys))</span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#desc">desc</a>(text):</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    <span class="py-string">&quot;Create a description div for the given text&quot;</span></span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <span class="py-keyword">return</span> text <span class="py-keyword">and</span> div(<span class="py-string">&quot;desc&quot;</span>, text) <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#escape">escape</a>(text):</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    <span class="py-keyword">for</span> p <span class="py-keyword">in</span> [(<span class="py-string">'&amp;'</span>, <span class="py-string">'&amp;amp;'</span>), (<span class="py-string">'&quot;'</span>, <span class="py-string">'&amp;quot;'</span>), (<span class="py-string">'&lt;'</span>, <span class="py-string">'&amp;lt;'</span>), (<span class="py-string">'&gt;'</span>, <span class="py-string">'&amp;gt;'</span>),</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">              (<span class="py-string">'('</span>, <span class="py-string">'&amp;#40;'</span>), (<span class="py-string">')'</span>, <span class="py-string">'&amp;#41;'</span>), (<span class="py-string">','</span>, <span class="py-string">'&amp;#44;'</span>), (<span class="py-string">','</span>, <span class="py-string">'&amp;#59;'</span>)]:</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        text = text.replace(*p)</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">    <span class="py-keyword">return</span> text</span>
<a id="line91"></a><span class="lineno"> 91</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#quote_as_id">quote_as_id</a>(text):</span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">    <span class="py-keyword">for</span> p <span class="py-keyword">in</span> [(<span class="py-string">' '</span>, <span class="py-string">'.'</span>),</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">              (<span class="py-string">'&lt;'</span>, <span class="py-string">'_L'</span>), (<span class="py-string">'&gt;'</span>, <span class="py-string">'_R'</span>), (<span class="py-string">'('</span>, <span class="py-string">'_l'</span>), (<span class="py-string">')'</span>, <span class="py-string">'_r'</span>), (<span class="py-string">'::'</span>, <span class="py-string">'-'</span>), (<span class="py-string">'~'</span>, <span class="py-string">'_t'</span>),</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">              (<span class="py-string">':'</span>, <span class="py-string">'.'</span>), (<span class="py-string">'&amp;'</span>, <span class="py-string">'_A'</span>), (<span class="py-string">'*'</span>, <span class="py-string">'_S'</span>), (<span class="py-string">' '</span>, <span class="py-string">'_s'</span>), (<span class="py-string">','</span>, <span class="py-string">'_c'</span>), (<span class="py-string">';'</span>, <span class="py-string">'_C'</span>),</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">              (<span class="py-string">'!'</span>, <span class="py-string">'_n'</span>), (<span class="py-string">'['</span>, <span class="py-string">'_b'</span>), (<span class="py-string">']'</span>, <span class="py-string">'_B'</span>), (<span class="py-string">'='</span>, <span class="py-string">'_e'</span>), (<span class="py-string">'+'</span>, <span class="py-string">'_p'</span>), (<span class="py-string">'-'</span>, <span class="py-string">'_m'</span>)]:</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        text = text.replace(*p)</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">    <span class="py-keyword">return</span> text</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Tags.html#replace_spaces">replace_spaces</a>(text):</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Replaces spaces in the given string with &amp;#160; sequences. Does NOT</span></span>
<a id="line104"></a><span class="lineno">104</span><span class="line"><span class="py-string">    replace spaces inside tags&quot;&quot;&quot;</span></span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">    <span class="py-comment"># original &quot;hello &lt;there stuff&gt; fool &lt;thing me bob&gt;yo&lt;a&gt;hi&quot;</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">    tags = text.split(<span class="py-string">'&lt;'</span>)</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">    <span class="py-comment"># now ['hello ', 'there stuff&gt; fool ', 'thing me bob&gt;yo', 'a&gt;hi']</span></span>
<a id="line109"></a><span class="lineno">109</span><span class="line">    tags = [x.split(<span class="py-string">'&gt;'</span>) <span class="py-keyword">for</span> x <span class="py-keyword">in</span> tags]</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">    <span class="py-comment"># now [['hello '], ['there stuff', ' fool '], ['thing me bob', 'yo'], ['a', 'hi']]</span></span>
<a id="line111"></a><span class="lineno">111</span><span class="line">    tags = reduce(<span class="py-keyword">lambda</span> x,y: x+y, tags)</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">    <span class="py-comment"># now ['hello ', 'there stuff', ' fool ', 'thing me bob', 'yo', 'a', 'hi']</span></span>
<a id="line113"></a><span class="lineno">113</span><span class="line">    <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(0,len(tags),2):</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        tags[i] = tags[i].replace(<span class="py-string">' '</span>, <span class="py-string">'&amp;#160;'</span>)</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">    <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(1,len(tags),2):</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        tags[i] = <span class="py-string">'&lt;'</span> + tags[i] + <span class="py-string">'&gt;'</span></span>
<a id="line117"></a><span class="lineno">117</span><span class="line">    <span class="py-keyword">return</span> <span class="py-string">''</span>.join(tags)</span>
<a id="line118"></a><span class="lineno">118</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
